# class Byebug::MethodCommand

Show methods of specific classes/modules/objects.

### Public Class Methods

description() click to toggle source

    # File lib/byebug/commands/method.rb, line 34
    def description
      prettify <<-EOD
        m[ethod] (i[nstance][ <obj>]|<class|module>)

        When invoked with "instance", shows instance methods of the object
        specified as argument or of self no object was specified.

        When invoked only with a class or module, shows class methods of the
        class or module specified as argument.
      EOD
    end

names() click to toggle source

    # File lib/byebug/commands/method.rb, line 30
    def names
      %w(method)
    end

### Public Instance Methods

execute() click to toggle source

    # File lib/byebug/commands/method.rb, line 14
    def execute
      obj = bb_eval(@match.post_match)
      result =
        if @match[1]
          prc('method.methods', obj.methods.sort) { |item, _| { name: item } }
        elsif !obj.is_a?(Module)
          pr('variable.errors.not_module', object: @match.post_match)
        else
          prc('method.methods', obj.instance_methods(false).sort) do |item, _|
            { name: item }
          end
        end
      puts result
    end

regexp() click to toggle source

    # File lib/byebug/commands/method.rb, line 10
    def regexp
      /^\s* m(?:ethod)? \s+ (i(:?nstance)?\s+)?/x
    end